// Sample02.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include "..\Lib\Dongle_API.h"
#pragma comment(lib, "..\\LIB\\Dongle_s.lib")

int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	DONGLE_HANDLE hDongle = NULL;
	BYTE buffer[1024];
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	DATA_FILE_LIST dataFileList[32];
	int dataLen = 0;

	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Dongle ARM. \n", nCount);

	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Dongle ARM. Return : 0x%08X . \n", dwRet);

	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//ļ
	DATA_FILE_ATTR dataAttr;
	dataAttr.m_Size = 1024;
	dataAttr.m_Lic.m_Read_Priv = 0;//СȨ
	dataAttr.m_Lic.m_Write_Priv = 0;//СȨ
	dwRet = Dongle_CreateFile(hDongle, FILE_DATA, 0x0001, (void *)&dataAttr);
	printf("CreateFile Return : 0x%08X . \n", dwRet);

	//дļ
	memset(buffer, 0x11, 1024);
	dwRet = Dongle_WriteFile(hDongle, FILE_DATA, 0x0001, 0, buffer, 1024);
	printf("Write File to Dongle ARM. Return : 0x%08X . \n", dwRet);

	//ȡļ
	memset(buffer, 0, 1024);
	dwRet = Dongle_ReadFile(hDongle, 0x0001, 0, buffer, 1024);
	printf("Read File from Dongle ARM. Return : 0x%08X . \n", dwRet);

	//ļ ҪԱȨ
	dataLen = 32*sizeof(DATA_FILE_LIST);
	memset(dataFileList, 0, 32 * sizeof(DATA_FILE_LIST));	
	dwRet = Dongle_ListFile(hDongle, FILE_DATA, (void*)dataFileList, &dataLen);
	printf("List File. Return 0x%08X, data file count: [%d]. \n", dwRet, dataLen/sizeof(DATA_FILE_LIST));

	//ɾļ
	dwRet = Dongle_DeleteFile(hDongle, FILE_DATA, 0x0001);
	printf("Delete File. Return 0x%08X \n", dwRet);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Dongle ARM. Return : 0x%08X . \n", dwRet);
	
	return 0;
}

