// Sample15.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <malloc.h>
#include "data.h"
#include "Windows.h"

#include "Dongle_API.h"


int main(int argc, char* argv[])
{
	int   nCount = 0;
	int   i = 0, j = 0;	
	int   nLen = 0;
	DWORD dwRet = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int  nRemainCount = 0;
	BYTE buffer[1024];
	BYTE *pOutData = NULL;
	int  nOutDataLen = 1024;
	int  nFunc = -1;
	int  nTotal = 0;
//	0220221803200314
	BYTE HID[8] = {0x02, 0x20, 0x22, 0x18, 0x03, 0x20, 0x03, 0x14};//󶨵Ӳк(HID)
		
	DONGLE_HANDLE hDongle = NULL;	
	FILE *fp = NULL;
	RSA_PUBLIC_KEY rsaPub;
	RSA_PRIVATE_KEY rsaPri;
	
	fp = fopen("update.Rsapub", "rb");
	if(NULL == fp) return 0;
	fread(&rsaPub, 1, sizeof(RSA_PUBLIC_KEY), fp);
	fclose(fp);

	fp = fopen("update.Rsapri", "rb");
	if(NULL == fp) return 0;
	fread(&rsaPri, 1, sizeof(RSA_PRIVATE_KEY), fp);
	fclose(fp);
	fp = NULL;

	// 	ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Dongle ARM. \n", nCount);

	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Dongle ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//Զ˽Կû
	dwRet = Dongle_SetUpdatePriKey(hDongle, &rsaPri);
	printf("Set update private key. Return: 0x%08X\n", dwRet);

	// - ()ļ
	pOutData = (BYTE *)malloc(1024 * sizeof(BYTE));
	memset(pOutData,0,1024);
	if(NULL == pOutData) return 0;
	nTotal = 1024;
	nFunc = UPDATE_FUNC_CreateFile; 
	DATA_FILE_ATTR dataAttr;
	dataAttr.m_Size = 1024;
	dataAttr.m_Lic.m_Read_Priv = 1;
	dataAttr.m_Lic.m_Write_Priv = 1;
	memset(buffer, 0, 1024);
	memcpy(buffer, &dataAttr, sizeof(DATA_FILE_ATTR));
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, sizeof(DATA_FILE_ATTR), pOutData, &nOutDataLen);
	printf("make update data [CreateFile]. Return: 0x%08X\n", dwRet);

	// - д()ļ
	pOutData = (BYTE *)realloc(pOutData, (nTotal+=2*1024));
	if(NULL == pOutData) return 0;
	nOutDataLen = 2*1024;
	memset(buffer, 0x12, 1024);//д
	nFunc = UPDATE_FUNC_WriteFile;	
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, 1024, pOutData+1024, &nOutDataLen);
	printf("make update data [WriteFile]. Return: 0x%08X\n", dwRet);

	// - ļȨ
	pOutData = (BYTE *)realloc(pOutData, (nTotal+= 1024));
	if(NULL == pOutData) return 0;
	nOutDataLen = 1024;
	DATA_LIC dataLic;
	dataLic.m_Read_Priv = 0;
	dataLic.m_Write_Priv = 1;
	memset(buffer, 0, 1024);//д
	memcpy(buffer, &dataLic, sizeof(DATA_LIC));
	nFunc = UPDATE_FUNC_FileLic;
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, sizeof(DATA_LIC), pOutData+3072, &nOutDataLen);
	printf("make update data [FileLic]. Return: 0x%08X\n", dwRet);
	
	// - ɾ()ļ
	pOutData = (BYTE *)realloc(pOutData, (nTotal+=1024));
	if(NULL == pOutData) return 0;
	nOutDataLen = 1024;
	nFunc = UPDATE_FUNC_DeleteFile;	
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, NULL, nFunc, FILE_DATA, 0x1122, 0, buffer, 0, pOutData+4096, &nOutDataLen);
	printf("make update data [DeleteFile]. Return: 0x%08X\n", dwRet);

	// - ؿִг
	pOutData = (BYTE *)realloc(pOutData, (nTotal+=(4*1024)));
	if(NULL == pOutData) return 0;
	nOutDataLen = (4*1024);
	EXE_FILE_INFO exeFileInfo;
	nCount = 1;//ִļ
	exeFileInfo.m_dwSize = EXE_SIZE_1;
	exeFileInfo.m_pData = g_progExeFile1;
	exeFileInfo.m_Priv = 0;
	exeFileInfo.m_wFileID = 0x1100;
	memset(buffer, 0, 1024);
	memcpy(buffer, &exeFileInfo, nCount * sizeof(EXE_FILE_INFO));
	nFunc = UPDATE_FUNC_DownloadExe;
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, NULL, nFunc, FILE_EXE, 0x1122, 0, buffer, (nCount * sizeof(EXE_FILE_INFO)), pOutData+5120, &nOutDataLen);
	printf("make update data [DownloadExe]. Return: 0x%08X\n", dwRet);
	
    // - ûPIN == Ӳк
	pOutData = (BYTE *)realloc(pOutData, (nTotal+=1024));
	if(NULL == pOutData) return 0;
	nOutDataLen = 1024;
	char cHid[9];
	memset(cHid, 0, 9);
	memcpy(cHid, HID, 8);
	nFunc = UPDATE_FUNC_UnlockUserPin;
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, "0225551555555514", nFunc, 0, 0, 0, 0, 0, pOutData+9216, &nOutDataLen);
	printf("make update data [UnlockUserPin]. Return: 0x%08X\n", dwRet);


	// - ʹ
	pOutData = (BYTE *)realloc(pOutData, (nTotal+=1024));
	if(NULL == pOutData) return 0;
	nOutDataLen = 1024;
	DWORD dwTime = 24;//24Сʱ
	memset(buffer, 0, 1024);
	memcpy(buffer, &dwTime, sizeof(DWORD));
	nFunc = UPDATE_FUNC_Deadline;	
	dwRet = Dongle_MakeUpdatePacketFromMother(hDongle, NULL, nFunc, 0, 0, 0, buffer, sizeof(DWORD), pOutData+10240, &nOutDataLen);
	printf("make update data [Deadline]. Return: 0x%08X\n", dwRet);

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Dongle ARM. Return: 0x%08X\n", dwRet);
	DeleteFileA("update.RyArmUdp");
	//ɵpOutData Էûʹ
	fp = fopen("update.RyArmUdp", "wb+");
	if(NULL == fp)
	{
		printf("fsdsdaf");
		return 0;
	}
	fwrite(pOutData, 1, nTotal, fp);
	fclose(fp);
	fp = NULL;

	if (pOutData != NULL)
	{
		free(pOutData);
	}
	pOutData = NULL;

	return 0;
}

